// FramePlot2D class for Plot2D lab
// This class creates the frame for the plots

// (c) J. Dean Brock, Rebecca F. Bruce, 2001, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.csci201.LabAids ;

/**
 * Creates frames for students plots within the Plot2D lab
 */
public class FramePlot2D {
    
    edu.unca.cs.csci201.LabAids.PanelPlot2D realPanel ;
    javax.swing.JFrame realFrame;

    int numPlotFunc = 0 ;

    /**
     * Contructor for FramePlot2D
     * @param title Name to display as title of the frame
     * 
     * @param width Width of panel to <B>display</B> plots.
     * This is <B>not</B> the width of the frame.
     * 
     * @param height Height of panel to <B>display</B> plots.
     * This is <B>not</B> the height of the frame.
     */
    public FramePlot2D(String title, int width, int height) {
        realPanel = new edu.unca.cs.csci201.LabAids.PanelPlot2D(width, height) ;
        realFrame = 
              edu.unca.cs.LabAids.FrameMaker.Component2Frame(realPanel, title) ;
    }
    
    private void INTaddPainter(SpecPlot2D plotObject, String plotName) {
        final SpecPlot2D thPlotObject = plotObject ;
        final String thPlotName = plotName ;
        Runnable thAddPainter = new Runnable() {
            public void run() {
                realPanel.addPainter(thPlotObject, thPlotName) ;
                realFrame.pack() ;
            }
        } ;
        try {
            javax.swing.SwingUtilities.invokeAndWait(thAddPainter) ;
        } catch (Exception e) {
            e.printStackTrace() ;
        }
        // javax.swing.SwingUtilities.invokeLater(thAddPainter) ;
    }
    
    /**
     * Add a plotter
     * @param plotObject Object to the plotted.  Must follow the
     * SpecPlot2D interface.
     * @param plotName Name for button to select the plot
     */
    public void addPainter(SpecPlot2D plotObject, String plotName) {
        ++numPlotFunc ;
        INTaddPainter(plotObject, plotName) ;
        // realPanel.addPainter(plotObject, plotName) ;
    }
    
    /**
     * Add a plotter with default title
     * @param plotObject Object to plot.  Must confirm to
     * SpecPlot2D interface.
     */
    public void addPainter(SpecPlot2D plotObject) {
        ++numPlotFunc ;
        INTaddPainter(plotObject, "Function " + numPlotFunc) ;
        // realPanel.addPainter(plotObject, "Function " + numPlotFunc) ;
    }
    
 }

